import java.io.ByteArrayOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;

/**
 * Пример использования класса ByteArrayOutputStream
 * */

public class Main {
    public static void main(String[] args) {
        String s = "Эти данные должны быть выведены в массив";
        byte[] bytes = s.getBytes();

        /*Конструируем объект типа ByteArrayOutputStream*/
        ByteArrayOutputStream f = new ByteArrayOutputStream();

        /*Записываем в поток вывода байты*/
        try {
            f.write(bytes);
        } catch (IOException e) {
            System.out.println("Ошибка записи в буфер");
            return;
        }

        /*Выводим содержимое на экран*/
        System.out.println("Используя метод toString(): " + f);

        /*Выводим в файл последовательность байтов с помощью метода writeTo*/
        System.out.println("Вывод в файл");
        try (FileOutputStream f2 = new FileOutputStream("test.txt")) {
            f.writeTo(f2);
        } catch (IOException e) {
            System.out.println("Ошибка вывода в файл");
            return;
        }

        /*Перемещаем текущий указатель на начало*/
        System.out.println("Установка в исходное состояние");
        f.reset();

        /*Добавляем в поток XXX*/
        for (int i = 0; i < 3; i++) {
            f.write('X');
        }

        /*Выводим содержимое на экран*/
        System.out.println(f);
    }
}
